{
  "nbformat": 4,
  "nbformat_minor": 0,
  "metadata": {
    "colab": {
      "name": "tesseractFinalllllllllll.ipynb",
      "provenance": [],
      "collapsed_sections": []
    },
    "kernelspec": {
      "name": "python3",
      "display_name": "Python 3"
    },
    "language_info": {
      "name": "python"
    }
  },
  "cells": [
    {
      "cell_type": "code",
      "execution_count": null,
      "metadata": {
        "id": "1HLrvvHDMht5",
        "outputId": "52a12978-feb3-4239-da3a-c0f068a8c052",
        "colab": {
          "base_uri": "https://localhost:8080/"
        }
      },
      "outputs": [
        {
          "output_type": "stream",
          "name": "stdout",
          "text": [
            "Reading package lists... Done\n",
            "Building dependency tree       \n",
            "Reading state information... Done\n",
            "tesseract-ocr is already the newest version (4.00~git2288-10f4998a-2).\n",
            "0 upgraded, 0 newly installed, 0 to remove and 39 not upgraded.\n",
            "Requirement already satisfied: pytesseract in /usr/local/lib/python3.7/dist-packages (0.3.9)\n",
            "Requirement already satisfied: Pillow>=8.0.0 in /usr/local/lib/python3.7/dist-packages (from pytesseract) (9.0.1)\n",
            "Requirement already satisfied: packaging>=21.3 in /usr/local/lib/python3.7/dist-packages (from pytesseract) (21.3)\n",
            "Requirement already satisfied: pyparsing!=3.0.5,>=2.0.2 in /usr/local/lib/python3.7/dist-packages (from packaging>=21.3->pytesseract) (3.0.8)\n",
            "Requirement already satisfied: pybind11 in /usr/local/lib/python3.7/dist-packages (2.9.2)\n",
            "Requirement already satisfied: fastwer in /usr/local/lib/python3.7/dist-packages (0.1.3)\n",
            "Requirement already satisfied: pybind11 in /usr/local/lib/python3.7/dist-packages (from fastwer) (2.9.2)\n"
          ]
        }
      ],
      "source": [
        "!sudo apt install tesseract-ocr\n",
        "!pip install pytesseract\n",
        "!pip install pybind11\n",
        "!pip install fastwer"
      ]
    },
    {
      "cell_type": "code",
      "source": [
        "import pytesseract\n",
        "import shutil\n",
        "import os\n",
        "import random\n",
        "try:\n",
        " from PIL import Image\n",
        "except ImportError:\n",
        " import Image\n",
        "import matplotlib.pyplot as plt\n",
        "import cv2\n",
        "import fastwer\n",
        "import numpy as np\n",
        "import pandas as pd\n",
        "from IPython.display import Image, display"
      ],
      "metadata": {
        "id": "jwbqXNT4Mo5d"
      },
      "execution_count": null,
      "outputs": []
    },
    {
      "cell_type": "code",
      "source": [
        "# Define reference text and output text\n",
        "ref = 'my name is kenneth'\n",
        "output = 'myy nime iz kenneth'\n",
        "\n",
        "# Obtain Sentence-Level Character Error Rate (CER)\n",
        "fastwer.score_sent(output, ref, char_level=True)"
      ],
      "metadata": {
        "colab": {
          "base_uri": "https://localhost:8080/"
        },
        "id": "QuFFiuGDb1nw",
        "outputId": "ab742cef-f90f-4a02-8281-c8df5bb2f301"
      },
      "execution_count": null,
      "outputs": [
        {
          "output_type": "execute_result",
          "data": {
            "text/plain": [
              "16.6667"
            ]
          },
          "metadata": {},
          "execution_count": 84
        }
      ]
    },
    {
      "cell_type": "code",
      "source": [
        "fastwer.score_sent(output, ref)\n"
      ],
      "metadata": {
        "colab": {
          "base_uri": "https://localhost:8080/"
        },
        "id": "-xlo8V6Fb40w",
        "outputId": "6d866760-275a-42cf-fd04-6a68a7c49932"
      },
      "execution_count": null,
      "outputs": [
        {
          "output_type": "execute_result",
          "data": {
            "text/plain": [
              "75.0"
            ]
          },
          "metadata": {},
          "execution_count": 85
        }
      ]
    },
    {
      "cell_type": "code",
      "source": [
        "img_list = os.listdir('/content/drive/MyDrive/huu')\n",
        "img_list = sorted(img_list)\n",
        "img_list"
      ],
      "metadata": {
        "colab": {
          "base_uri": "https://localhost:8080/"
        },
        "id": "1nkXVCXNb5AX",
        "outputId": "d86f213e-7f69-4b8f-dc7a-43a71af028f4"
      },
      "execution_count": null,
      "outputs": [
        {
          "output_type": "execute_result",
          "data": {
            "text/plain": [
              "['800_3566431_8sq3celupvg6gm1a5d9tosdp0549ix3r9dudzj0s_lamhah-arabic-typeface.png',\n",
              " 'Arabic_Typesetting_Font.svg.png',\n",
              " 'arabic-words-and-phrases-vector-22578359.jpg',\n",
              " 'capr10.png',\n",
              " 'capr2.png',\n",
              " 'cdd.jpg',\n",
              " 'cddd.jpg',\n",
              " 'font_preview-ae8a8c44055469537eec30890fd91d074584.png',\n",
              " 'hand-writing-on-blackboard-language-260nw-480440053.jpg.jpg',\n",
              " 'kashida-justification.png',\n",
              " 'pngtree-ramadan-kareem-greetings-arabic-text-typogtraphy-png-image_3087316.jpg',\n",
              " 'r.jpg',\n",
              " 'sti.jpg',\n",
              " 'traditional-arabic-regular.png']"
            ]
          },
          "metadata": {},
          "execution_count": 86
        }
      ]
    },
    {
      "cell_type": "code",
      "source": [
        "for i, img in enumerate(img_list):\n",
        "  print(f'Display sample image {i+1} - {img}')\n",
        "  display(Image(filename=f'/content/drive/MyDrive/huu/{img}'))\n"
      ],
      "metadata": {
        "colab": {
          "base_uri": "https://localhost:8080/",
          "height": 1000
        },
        "id": "PhhNmdI5b5NO",
        "outputId": "7d0ff0a6-a2b8-4188-e988-94bc0bb97cc6"
      },
      "execution_count": null,
      "outputs": [
        {
          "output_type": "stream",
          "name": "stdout",
          "text": [
            "Display sample image 1 - 800_3566431_8sq3celupvg6gm1a5d9tosdp0549ix3r9dudzj0s_lamhah-arabic-typeface.png\n"
          ]
        },
        {
          "output_type": "display_data",
          "data": {
            "text/plain": [
              "<IPython.core.display.Image object>"
            ],
            "image/png": "[encoded data, 45176 characters]\n"
          },
          "metadata": {}
        },
        {
          "output_type": "stream",
          "name": "stdout",
          "text": [
            "Display sample image 2 - Arabic_Typesetting_Font.svg.png\n"
          ]
        },
        {
          "output_type": "display_data",
          "data": {
            "text/plain": [
              "<IPython.core.display.Image object>"
            ],
            "image/png": "[encoded data, 38380 characters]\n"
          },
          "metadata": {}
        },
        {
          "output_type": "stream",
          "name": "stdout",
          "text": [
            "Display sample image 3 - arabic-words-and-phrases-vector-22578359.jpg\n"
          ]
        },
        {
          "output_type": "display_data",
          "data": {
            "text/plain": [
              "<IPython.core.display.Image object>"
            ],
            "image/jpeg": "[encoded data, 210328 characters]\n"
          },
          "metadata": {}
        },
        {
          "output_type": "stream",
          "name": "stdout",
          "text": [
            "Display sample image 4 - capr10.png\n"
          ]
        },
        {
          "output_type": "display_data",
          "data": {
            "text/plain": [
              "<IPython.core.display.Image object>"
            ],
            "image/png": "[encoded data, 241724 characters]\n"
          },
          "metadata": {}
        },
        {
          "output_type": "stream",
          "name": "stdout",
          "text": [
            "Display sample image 5 - capr2.png\n"
          ]
        },
        {
          "output_type": "display_data",
          "data": {
            "text/plain": [
              "<IPython.core.display.Image object>"
            ],
            "image/png": "[encoded data, 57712 characters]\n"
          },
          "metadata": {}
        },
        {
          "output_type": "stream",
          "name": "stdout",
          "text": [
            "Display sample image 6 - cdd.jpg\n"
          ]
        },
        {
          "output_type": "display_data",
          "data": {
            "text/plain": [
              "<IPython.core.display.Image object>"
            ],
            "image/jpeg": "[encoded data, 356508 characters]\n"
          },
          "metadata": {}
        },
        {
          "output_type": "stream",
          "name": "stdout",
          "text": [
            "Display sample image 7 - cddd.jpg\n"
          ]
        },
        {
          "output_type": "display_data",
          "data": {
            "text/plain": [
              "<IPython.core.display.Image object>"
            ],
            "image/jpeg": "[encoded data, 104200 characters]\n"
          },
          "metadata": {}
        },
        {
          "output_type": "stream",
          "name": "stdout",
          "text": [
            "Display sample image 8 - font_preview-ae8a8c44055469537eec30890fd91d074584.png\n"
          ]
        },
        {
          "output_type": "display_data",
          "data": {
            "text/plain": [
              "<IPython.core.display.Image object>"
            ],
            "image/png": "[encoded data, 11232 characters]\n"
          },
          "metadata": {}
        },
        {
          "output_type": "stream",
          "name": "stdout",
          "text": [
            "Display sample image 9 - hand-writing-on-blackboard-language-260nw-480440053.jpg.jpg\n"
          ]
        },
        {
          "output_type": "display_data",
          "data": {
            "text/plain": [
              "<IPython.core.display.Image object>"
            ],
            "image/jpeg": "[encoded data, 23968 characters]\n"
          },
          "metadata": {}
        },
        {
          "output_type": "stream",
          "name": "stdout",
          "text": [
            "Display sample image 10 - kashida-justification.png\n"
          ]
        },
        {
          "output_type": "display_data",
          "data": {
            "text/plain": [
              "<IPython.core.display.Image object>"
            ],
            "image/png": "[encoded data, 43860 characters]\n"
          },
          "metadata": {}
        },
        {
          "output_type": "stream",
          "name": "stdout",
          "text": [
            "Display sample image 11 - pngtree-ramadan-kareem-greetings-arabic-text-typogtraphy-png-image_3087316.jpg\n"
          ]
        },
        {
          "output_type": "display_data",
          "data": {
            "text/plain": [
              "<IPython.core.display.Image object>"
            ],
            "image/jpeg": "[encoded data, 22516 characters]\n"
          },
          "metadata": {}
        },
        {
          "output_type": "stream",
          "name": "stdout",
          "text": [
            "Display sample image 12 - r.jpg\n"
          ]
        },
        {
          "output_type": "display_data",
          "data": {
            "text/plain": [
              "<IPython.core.display.Image object>"
            ],
            "image/jpeg": "[encoded data, 52708 characters]\n"
          },
          "metadata": {}
        },
        {
          "output_type": "stream",
          "name": "stdout",
          "text": [
            "Display sample image 13 - sti.jpg\n"
          ]
        },
        {
          "output_type": "display_data",
          "data": {
            "text/plain": [
              "<IPython.core.display.Image object>"
            ],
            "image/jpeg": "[encoded data, 10944 characters]\n"
          },
          "metadata": {}
        },
        {
          "output_type": "stream",
          "name": "stdout",
          "text": [
            "Display sample image 14 - traditional-arabic-regular.png\n"
          ]
        },
        {
          "output_type": "display_data",
          "data": {
            "text/plain": [
              "<IPython.core.display.Image object>"
            ],
            "image/png": "[encoded data, 10240 characters]\n"
          },
          "metadata": {}
        }
      ]
    },
    {
      "cell_type": "code",
      "source": [
        "df_output = pd.DataFrame(columns = ['img_filename', 'ocr_output'])\n"
      ],
      "metadata": {
        "id": "y5VeSMz6cpJ9"
      },
      "execution_count": null,
      "outputs": []
    },
    {
      "cell_type": "code",
      "source": [
        "!pip install Pillow==9.0.1\n"
      ],
      "metadata": {
        "id": "iBPeB8sDMpAj",
        "colab": {
          "base_uri": "https://localhost:8080/"
        },
        "outputId": "cbbd54e8-209d-4a76-d0d0-972f323abd18"
      },
      "execution_count": null,
      "outputs": [
        {
          "output_type": "stream",
          "name": "stdout",
          "text": [
            "Requirement already satisfied: Pillow==9.0.1 in /usr/local/lib/python3.7/dist-packages (9.0.1)\n"
          ]
        }
      ]
    },
    {
      "cell_type": "code",
      "source": [
        "\n",
        "for img in img_list:\n",
        "  im = cv2.imread(f'/content/drive/MyDrive/huu/{img}')\n",
        "  img_rgb = cv2.cvtColor(im, cv2.COLOR_BGR2RGB)\n",
        "  extract = pytesseract.image_to_string(img_rgb,lang=\"ara\")\n",
        "  print(extract)\n",
        "  print(img)\n",
        "  dictionary = {'img_filename':img, 'ocr_output':str(extract)}\n",
        "  df_output = df_output.append(dictionary, ignore_index=True)"
      ],
      "metadata": {
        "id": "lEObc9RShc47",
        "colab": {
          "base_uri": "https://localhost:8080/"
        },
        "outputId": "09eb5874-bd0b-4d2b-8267-178966112ff6"
      },
      "execution_count": null,
      "outputs": [
        {
          "output_type": "stream",
          "name": "stdout",
          "text": [
            "خط لمحة النحيف\n",
            "خط لمحة العادي\n",
            "خط لمحة العريض\n",
            "\n",
            " \n",
            "\f\n",
            "800_3566431_8sq3celupvg6gm1a5d9tosdp0549ix3r9dudzj0s_lamhah-arabic-typeface.png\n",
            "\f\n",
            "Arabic_Typesetting_Font.svg.png\n",
            "ما\n",
            "ما 5\n",
            "|\n",
            "اسل ملا\n",
            ": 2\n",
            "|\n",
            "د اننا لام\n",
            "م\n",
            "لكحول\n",
            "\n",
            " \n",
            "\f\n",
            "arabic-words-and-phrases-vector-22578359.jpg\n",
            "يقول الله تبارك وتعال واضرب لهم مثلا اصحاب القري اذ جاها المرسلون اذا ارسلنا اليهم اثنين فكذبوهما\n",
            "فعززنا بثالث فقالوا انا اليكم مرسلون اولا ما هي قصتهم لم يذكر لنا القرن الكريم من هم اصحاب القري ولا ما\n",
            "هي القري وهناك روايات كثير ولا طال من ورا الجر معها انما ما يهمنا من هذه القص هي العبر والعظ منها\n",
            "فهي قري ارسل الله اليها رسولين فكذبوهما اهل تلك القري فعززهما الله برسول ثالث وتقدموا ثلائتهم\n",
            "بدعواهم ودعوتهم من جديد فقالوا انا اليكم مرسلون وهنا اعترض اهل القري بالاعتراضات المكرر في تاريخ\n",
            "الرسل والرسالات قالوا ما انتم الا بشر مثلنا وما انزل الرحمن من شي ان انتم الا تكذبون وفي ثق الممن\n",
            "المطمن ال الصدق العارف بحدود وظيفته اجابهم الرسل قالوا ربنا يعلم انا اليكم لمرسلون وما علينا الا البلاغ\n",
            "المبين اي ان الله يعلم هذا ويكفي وان وظيف الرسل هي البلا وقد ادوه والناس بعد ذلك احرار فيما يتخذونه\n",
            "لانفسهم من تصرف وفيما يحملون في تصرفهم من اوزار والامر بين الرسل وبين الناس هو امر ذلك التبليغ\n",
            "عن الله تعال فمت تحقق ذلك فالمر كله بعد ذلك لله ولكن المكذبين كعادتهم لا يخذون الامور عل هذا المخذ\n",
            "الواضح ولا يطيقون وجود الدعا ال الهد فتخذهم العز بالاثم ويعمدون ال الاسلوب الغليظ في مقاوم الحج لان\n",
            "الباطل ضيق الصدر قالوا انا تطيرنا بكم لن لم تنتهوا لترجمنكم وليمسنكم منا عذاب اليم وهكذا اسغر الباطل\n",
            "عن غشمه واطلق عل الهدا تهديده ولكن الواجب عل الرسل ان يسيروا في طريق دعوتهم لدا الواجب عليهم\n",
            "فردوا عليهم قالوا طاركم. معكم لان القول بالتشام خراف وواجب الرسل ان يبينوا لقومهم انها خراف وان حظهم\n",
            "ونصيبهم من خير ومن شر لا يتيهم من خارج انقسهم انما هو معهم مرتبط بنواياهم واعمالهم متوقف عل\n",
            "كسبهم وعملهم وفي وسعهم ان يجعلوا حظهم ونصيبهم خيرا او ان يجعلوه شرا ان ذكرتم يعن اتعذبونا\n",
            "وترجمونا لاننا تذكركم افهذا جزاا التذكير بل انتم قوم مسرفون يعن تجاوزتم الحدود وتردون عل الدعو ال الخير\n",
            "تردون بالرجم والتعذيب ولكن داما تجد الخير في قلوب بعض الرجال وتجد الفطر السليم في الداعي المازر\n",
            "والمناصر لدين الحق فهذا رجل يسمع لدعو الحق فينطق بكلم الحق المبين قال تعالوجا من قص المدين رجل\n",
            "يسع قال يا قوم اتبعوا المرسلين انبعوا من لا يسلكم اجرا وهم مهتدون اي ان الذي يدعو مثل هذه الدعو وهو\n",
            "لا يطلب اجرا انه لصادق والا فما الذي يحمله عل هذا العنا ان لم يكن يلب تكليقا من الله تعال ودعوتهم\n",
            "واضح فهم يدعون ال اله واحد ويدعون ال منهج سليم ثم عاد هذا الرجل الممن يتحدث اليهم عن نفسه وعن\n",
            "اسباب ايمانه ومالي لا اعبد الذي فطرني واليه ترجعون يتسال لم لا اعبد الذي فطرني وهو اليه المرجع والمصير\n",
            "ثم اخذ يبين لهم ان من يخالف هذا المنهج فنهايته معروف ثم يلق كلم النهاي اني منت بربكم فاسمعون هكذا\n",
            "الق كلم الايمان الوائق واشهدهم عليها ويوحي سياق القص ان قومه لم يمهلوه وقتلوه وتنتهي الدنيا ونراه في\n",
            "العالم الخر وقد اكرمه الله بدخول الجن قيل ادخل الجن قال يا ليت قومي يعلمون بما غفر لي ربي وجعلني من\n",
            "المكرمين ونر الرجل الممن بعد ان اراه الله منزلته في الجن يقول ويتمن لو يراه قومه وقد اتاه الله من الكرام\n",
            "والمغفر ليعرفوا الحق معرف اليقين ويخبرنا الله تعال انه انتقم من قومه بعد قتلهم اياه غضبا منه تبارك وتعال\n",
            "عليهم لانهم كذبوا رسله وقتلوا وليه ويذكر الله تعال ما انزل عليهم من عذاب قال تعالان كانت الا صيح واحد\n",
            "فذا هم خامدون قال علما التفسير بعث الله اليهم جبريل عليه السلام فخذ بعضادتي الباب الذي ببلدهم ثم\n",
            "صاح بهم صيح واحد فذا هم خامدون قد اخمدت اصواتهم وسكنت حركانهم ولم يبق منهم عين تطرف ولا\n",
            "نفس تتردد وهذه نهاي كل من كذب بيات الله ورسله واعترض عل امر الله تعال ونستفيد من هذه القص\n",
            "اشيا مهم منها التصديق بكل ما جا الرسل الكرام والايمان بالله واليوم الخر الدعو ال الله تعال واجب عل كل\n",
            "مسلم تجاه اهله وكل من هم تحت امرته ورعايته جزا من يمن بالله ورسله دخول الجن والتنعم بها ندعو الله ان\n",
            "يجعلنا ممن يتعظون بالقصص القرني وهو نعم المول ونعم النصير\n",
            "\f\n",
            "capr10.png\n",
            "كتبت بدري الاسماعيلي بالتعاون بين مدرس جميل بنت ثابت وعماد شون الطلاب بجامع السلطان قابوس\n",
            "ممثل بجماع الفنون التشكيلي تم افتتاح المعرض الغني عبر بواب الزمن وذلك تحت رعاي سعاد المكرم\n",
            "لميس بنت عبدالله الطاي عضو مجلس الدول وذلك بمركز خدمات الطلاب حيث ضم المعرض مجموع من\n",
            "اللوحات القني والمعماري والمستوحا من البي العماني وتم في اللوحات توظيف فن الكولاج والذي يعني فن\n",
            "التجميع والالصاق ويعتبر فن الكولاج من وساط التعابير الفني الحديث قوامه توظيف خامات فني متنوع\n",
            "كقصاصات الاوراق والاقمش والكرتون والمواد المستهلك تضاف اليها بعض الخطوط والابواب لاحداث\n",
            "تثيرات فني ثلائي الابعاد تضفي فضا اللوح وجا المعرض اختتاما للحلق التي اشرف عليها الدكتور تيسير\n",
            "طبيشات اخصاي الفنون التشكيلي والتي استمرت عل مد اسبوع وقد شارك في الحلق عدد من مدرسي\n",
            "التربي الفني التابع لمديري السيب\n",
            "\f\n",
            "capr2.png\n",
            " \n",
            "\n",
            "2 ب\n",
            "٠ أ ا بي\n",
            "في المحطة\n",
            "\n",
            "صَعِدتُ آلْقِطَار رَجَيْتُ إلى أَوَلِ مَفْعَد\n",
            "وَوَضَعْتُ خَقَيبْتي عَلَى آلرّف. وَوَقَفُ 1\n",
            "النَافِذَةِ أنظر إلى آلنّاس .\n",
            "\n",
            "الْمُسَافِرُونَ شُسْرِعُون؛ تَوَجهُونَ نَحُرّ\n",
            "لعَرَبَات. وَهُمَ َحْملُونَ َنِعَتهُي + بَيَتَمَا ترتفع\n",
            "أَصْوَاتُ بَاعَةِ آلصُحْف وَالْمَشْرُوبَات.\n",
            "\n",
            "ذَوْتِ آلصَقَارَ وب لْقِطَارُ تَحَرَى. وَبَقِيتٌ\n",
            "اق رب افق أَرَاقبُ حَرَكَةَ آقاس.\n",
            "والْأيدي آلني ودع\n",
            "\n",
            " \n",
            "\n",
            " \n",
            "\n",
            " \n",
            "\n",
            " \n",
            "\n",
            " \n",
            "\f\n",
            "cdd.jpg\n",
            " \n",
            "\f\n",
            "cddd.jpg\n",
            "موقع الفونت\n",
            "\f\n",
            "font_preview-ae8a8c44055469537eec30890fd91d074584.png\n",
            " \n",
            "\f\n",
            "hand-writing-on-blackboard-language-260nw-480440053.jpg.jpg\n",
            "بعد زبع قرن من الغياب\n",
            "والشوق لرؤية الاهل توفيت\n",
            "الراكبة جورجيت بشير (64\n",
            "عاما) وهي كندية من اصل\n",
            "مصري؛ داخل صالة يرانزيت\n",
            "مطار القاهرة بعد اول زيارة لها\n",
            "الى مصر متنثرة بإصابتها بهبوط\n",
            "حاد في الدورة الدموية قبل\n",
            "دقائق من صعودها الى الطائرة\n",
            "المصرية المتجهة الى الولايات\n",
            "المتحدة الاميركية.\n",
            "\n",
            " \n",
            "\n",
            " \n",
            "\n",
            " \n",
            "\n",
            " \n",
            "\f\n",
            "kashida-justification.png\n",
            "+\n",
            "\f\n",
            "pngtree-ramadan-kareem-greetings-arabic-text-typogtraphy-png-image_3087316.jpg\n",
            "كن على ثقة أنك شخص عظم أوجده الله لهدف وغاية\n",
            "ووضع فيك ما يميزك عن غيرك ؛ قد تتعثر في طريقك\n",
            "و قد تفقد توازنك و تحزن وتنطفئ روحك\n",
            "لكنك لست بعاجز أو أقل من غيرك\n",
            "لا تلتفت لكل ما يحبطك. أنت وحدك\n",
            "من يستطيع أن يفجّر طاقاتك. أنت من تصنع سعادتك\n",
            "وتغير حياتك للأفضل . تأمل نفسك فقط\n",
            "\f\n",
            "r.jpg\n",
            "تحيّة لكل بنت لون عيونها بئية ©\n",
            "\n",
            " \n",
            "\f\n",
            "sti.jpg\n",
            "احب نفسك أولا\n",
            "\f\n",
            "traditional-arabic-regular.png\n"
          ]
        }
      ]
    },
    {
      "cell_type": "code",
      "source": [
        "# Create new columns for reference, CER and WER\n",
        "df_output['ref_text'] = ''\n",
        "df_output['cer'] = ''\n",
        "df_output['wer'] = ''\n",
        "\n",
        "# Replace new lines in output\n",
        "df_output['ocr_output'] = df_output['ocr_output'].apply(lambda x: x.replace(']','').replace('[','').replace(\"'\",'').replace(\"\\n\",''))\n",
        "\n",
        "df_output.loc[df_output['img_filename'] == '800_3566431_8sq3celupvg6gm1a5d9tosdp0549ix3r9dudzj0s_lamhah-arabic-typeface.png', 'ref_text'] = \"خط لمحة النحيف خط لمحة العادي خط لمحة العريض\"\n",
        "df_output.loc[df_output['img_filename'] == 'Arabic_Typesetting_Font.svg.png', 'ref_text'] = \"خط الطباعة العربي\"\n",
        "df_output.loc[df_output['img_filename'] == 'font_preview-ae8a8c44055469537eec30890fd91d074584.png', 'ref_text'] = \"موقع الفونت\"\n",
        "df_output.loc[df_output['img_filename'] == 'traditional-arabic-regular.png', 'ref_text'] = \"أحب نفسك أولا\"\n",
        "df_output.loc[df_output['img_filename'] == 'r.jpg', 'ref_text'] = \"كن على ثقة أنّك شخص عظيم أوجده الله لهدف وغاية، ووضع فيك ما يميزك، عن غيرك, قد تتعثر في طريقك و قد تفقد توازنك و تحزن وتنطفئ روحك، لكنك لست بعاجز أو أقل من غيرك، لا تلتفت لكل ما يحبطك، أنت وحدك من يستطيع أن يفجّر طاقاتك، أنت من تصنع سعادتك وتغير حياتك للأفضل , تأمل نفسك فقط\"\n",
        "df_output.loc[df_output['img_filename'] == 'arabic-words-and-phrases-vector-22578359.jpg', 'ref_text'] = \"مايسان ماذا تريد ماذا حصل أديسون ماذا قلتم ما هذا ماذا تعمل سلام ماذا تحتاج الكحول\"\n",
        "df_output.loc[df_output['img_filename'] == 'pngtree-ramadan-kareem-greetings-arabic-text-typogtraphy-png-image_3087316.jpg', 'ref_text'] = \"رمضان كريم\"\n",
        "df_output.loc[df_output['img_filename'] == 'kashida-justification.png', 'ref_text'] = \"بعد زبع قرن من الغياب والشوق لرؤية الاهل توفيت الراكبة جورجيت بشير (٦٩ عاما) وهي كندية من اصل مصري، داخل صالة يرانزيت مطار القاهرة بعد اول زيارة لها الى مصر متئثرة بإصابتها بهبوط حاد في الدورة الدموية قبل دقائق من صعودها الى الطائرة المصرية المتجهة الى الولايات المتحدة الاميركية\"\n",
        "df_output.loc[df_output['img_filename'] == 'cddd.jpg', 'ref_text'] = \"أدبُ المرءِ خيرٌ من ذهبهِ\"\n",
        "df_output.loc[df_output['img_filename'] == 'cdd.jpg', 'ref_text'] = \"صَعِدْتُ القِطار، تَوَجَّهْتُ إلى أَوَّلِ مَقْعَد، وَوَضَعْتُ حَقِيبَتِي عَلَى الرَّفّ، وَوَقَفْتُ أمام النَّافِدَةِ أَنْظُرُ إِلَى النَّاس المُسَافِرُون مُسْرِعُون، يَتَوَجَّهُون نَحْوَ العَرَبَات، وَ هُمْ يَحْمِلُون أَمِْتعَتَهُم، بَيْنَمَا تَرْتَفِع أَصْوَاتُ بَاعَةِ الصُّحُفِ وَ المَشْرُوبَات دَوَّتِ الصَّفَّارَةُ، وَ بَدَأَ القِطَارُيَتَحَرّكَ، وَ بَقِيتُ واقِفًا قُرْبَ النَّافِذَة، أُرَاقِبُ حَرَكَةَ النَّاس، وَ الأَيْدِي اّلتِي تُوَدِّع\"\n",
        "df_output.loc[df_output['img_filename'] == 'sti.jpg', 'ref_text'] = \"تحيّة لكل بنت لون عيونهآ بنية\"\n",
        "df_output.loc[df_output['img_filename'] == 'capr2.png', 'ref_text'] = \"كتبت بدري الاسماعيلي بالتعاون بين مدرس جميل بنت ثابت وعماد شون الطلاب بجامع السلطان قابوس ممثل بجماع الفنون التشكيلي تم افتتاح المعرض الغني عبر بواب الزمن وذلك تحت رعاي سعاد المكرم لميس بنت عبدالله الطاي عضو مجلس الدول وذلك بمركز خدمات الطلاب حيث ضم المعرض مجموع من اللوحات الفني والمعماري والمستوحا من البي العماني وتم في اللوحات توظيف فن الكولاج والذي يعني فن التجميع والالصاق ويعتبر فن الكولاج من وساط التعابير الفني الحديث قوامه توظيف خامات فني متنوع كقصاصات الاوراق والاقمش والكرتون والمواد المستهلك تضاف اليها بعض الخطوط والابواب لاحداث تثيرات فني ثلاثي الابعاد تضفي فضا اللوح وجا المعرض اختتاما للحلق التي اشرف عليها الدكتور تيسير طبيشات اخصاي الفنون التشكيلي والتي استمرت عل مد اسبوع وقد شارك في الحلق عدد من مدرسي التربي الفني التابع لمديري السيب\"\n",
        "df_output.loc[df_output['img_filename'] == 'capr10.png', 'ref_text'] = \"يقول الله تبارك وتعال واضرب لهم مثلا اصحاب القري اذ جاها المرسلون اذا ارسلنا اليهم اثنين فكذبوهما فعززنا بثالث فقالوا انا اليكم مرسلون اولا ما هي قصتهم لم يذكر لنا القرن الكريم من هم اصحاب القري ولا ماهي القري وهناك روايات كثير ولا طال من ورا الجر معها انما ما يهمنا من هذه القص هي العبر والعظ منها فهي قري ارسل الله اليها رسولين فكذبوهما اهل تلك القري فعززهما الله برسول ثالث وتقدموا ثلائتهم بدعواهم ودعوتهم من جديد فقالوا انا اليكم مرسلون وهنا اعترض اهل القري بالاعتراضات المكرر في تاريخ الرسل والرسالات قالوا ما انتم الا بشر مثلنا وما انزل الرحمن من شي ان انتم الا تكذبون وفي ثق الممن المطمن ال الصدق العارف بحدود وظيفته اجابهم الرسل قالوا ربنا يعلم انا اليكم لمرسلون وما علينا الا البلاغ المبين اي ان الله يعلم هذا ويكفي وان وظيف الرسل هي البلاغ وقد ادوه والناس بعد ذلك احرار فيما يتخذونه لانفسهم من تصرف وفيما يحملون في تصرفهم من اوزار والامر بين الرسل وبين الناس هو امر ذلك التبليغ عن الله تعال فمت تحقق ذلك فالمر كله بعد ذلك لله ولكن المكذبين كعادتهم لا يخذون الامور عل هذا المخذ الواضح ولا يطيقون وجود الدعا ال الهد فتخذهم العز بالاثم ويعمدون ال الاسلوب الغليظ في مقاوم الحج لان الباطل ضيق الصدر قالوا انا تطيرنا بكم لن لم تنتهوا لنرجمنكم وليمسنكم منا عذاب اليم وهكذا اسفر الباطل عن غشمه واطلق عل الهدا تهديده ولكن الواجب عل الرسل ان يسيروا في طريق دعوتهم لدا الواجب عليهم فردوا عليهم قالوا طاركم معكم لان القول بالتشام خراف وواجب الرسل ان يبينوا لقومهم انها خراف وان حظهم ونصيبهم من خير ومن شر لا يتيهم من خارج انقسهم انما هو معهم مرتبط بنواياهم واعمالهم متوقف عل كسبهم وعملهم وفي وسعهم ان يجعلوا حظهم ونصيبهم خيرا او ان يجعلوه شرا ان ذكرتم يعن اتعذبون وترجمونا لاننا نذكركم افهذا جزاا التذكير بل انتم قوم مسرفون يعن تجاوزتم الحدود وتردون عل الدعو ال الخيرتردون بالرجم والتعذيب ولكن داما تجد الخير في قلوب بعض الرجال وتجد الفطر السليم في الداعي المازر والمناصر لدين الحق فهذا رجل يسمع لدعو الحق فينطق بكلم الحق المبين قال تعالوجا من قص المدين رجل يسع قال يا قوم اتبعوا المرسلين اتبعوا من لا يسلكم اجرا وهم مهتدون اي ان الذي يدعو مثل هذه الدعو وهو لا يطلب اجرا انه لصادق والا فما الذي يحمله عل هذا العنا ان لم يكن يلب تكليفا من الله تعال ودعوتهم واضح فهم يدعون ال اله واحد ويدعون ال منهج سليم ثم عاد هذا الرجل الممن يتحدث اليهم عن نفسه وعن اسباب ايمانه ومالي لا اعبد الذي فطرني واليه ترجعون يتسال لم لا اعبد الذي فطرني وهو اليه المرجع والمصير ثم اخذ يبين لهم ان من يخالف هذا المنهج فنهايته معروف ثم يلق كلم النهاي اني منت بربكم فاسمعون هكذا الق كلم الايمان الوائق واشهدهم عليها ويوحي سياق القص ان قومه لم يمهلوه وقتلوه وتنتهي الدنيا ونراه في العالم الخر وقد اكرمه الله بدخول الجن قيل ادخل الجن قال يا ليت قومي يعلمون بما غفر لي ربي وجعلني من المكرمين ونر الرجل الممن بعد ان اراه الله منزلته في الجن يقول ويتمن لو يراه قومه وقد اتاه الله من الكرام والمغفر ليعرفوا الحق معرف اليقين ويخبرنا الله تعال انه انتقم من قومه بعد قتلهم اياه غضبا منه تبارك وتعال عليهم لانهم كذبوا رسله وقتلوا وليه ويذكر الله تعال ما انزل عليهم من عذاب قال تعالان كانت الا صيح واحد فذا هم خامدون قال علما التفسير بعث الله اليهم جبريل عليه السلام فخذ بعضادتي الباب الذي ببلدهم ثم صاح بهم صيح واحد فذا هم خامدون قد اخمدت اصواتهم وسكنت حركانهم ولم يبق منهم عين تطرف ولا نفس تتردد وهذه نهاي كل من كذب بيات الله ورسله واعترض عل امر الله تعال ونستفيد من هذه القص اشيا مهم منها التصديق بكل ما جا الرسل الكرام والايمان بالله واليوم الخر الدعو ال الله تعال واجب عل كل مسلم تجاه اهله وكل من هم تحت امرته ورعايته جزا من يمن بالله ورسله دخول الجن والتنعم بها ندعو الله ان يجعلنا ممن يتعظون بالقصص القرني وهو نعم المول ونعم النصير\"\n",
        "df_output.loc[df_output['img_filename'] == 'hand-writing-on-blackboard-language-260nw-480440053.jpg.jpg', 'ref_text'] = \"العربية\"\n",
        "\n",
        "\n"
      ],
      "metadata": {
        "id": "Ges5X0aXdZDy"
      },
      "execution_count": null,
      "outputs": []
    },
    {
      "cell_type": "code",
      "source": [
        "df_output\n"
      ],
      "metadata": {
        "id": "6bbvVnZddZGG",
        "colab": {
          "base_uri": "https://localhost:8080/",
          "height": 488
        },
        "outputId": "65314886-4765-47db-d412-6834b0618b7f"
      },
      "execution_count": null,
      "outputs": [
        {
          "output_type": "execute_result",
          "data": {
            "text/plain": [
              "                                         img_filename  \\\n",
              "0   800_3566431_8sq3celupvg6gm1a5d9tosdp0549ix3r9d...   \n",
              "1                     Arabic_Typesetting_Font.svg.png   \n",
              "2        arabic-words-and-phrases-vector-22578359.jpg   \n",
              "3                                          capr10.png   \n",
              "4                                           capr2.png   \n",
              "5                                             cdd.jpg   \n",
              "6                                            cddd.jpg   \n",
              "7   font_preview-ae8a8c44055469537eec30890fd91d074...   \n",
              "8   hand-writing-on-blackboard-language-260nw-4804...   \n",
              "9                           kashida-justification.png   \n",
              "10  pngtree-ramadan-kareem-greetings-arabic-text-t...   \n",
              "11                                              r.jpg   \n",
              "12                                            sti.jpg   \n",
              "13                     traditional-arabic-regular.png   \n",
              "\n",
              "                                           ocr_output  \\\n",
              "0        خط لمحة النحيفخط لمحة العاديخط لمحة العريض \n",
              "   \n",
              "1                                                   \n",
              "   \n",
              "2                ماما 5|اسل ملا: 2|د اننا لامملكحول \n",
              "   \n",
              "3   يقول الله تبارك وتعال واضرب لهم مثلا اصحاب الق...   \n",
              "4   كتبت بدري الاسماعيلي بالتعاون بين مدرس جميل بن...   \n",
              "5    2 ب٠ أ ا بيفي المحطةصَعِدتُ آلْقِطَار رَجَيْت...   \n",
              "6                                                   \n",
              "   \n",
              "7                                        موقع الفونت\n",
              "   \n",
              "8                                                   \n",
              "   \n",
              "9   بعد زبع قرن من الغيابوالشوق لرؤية الاهل توفيتا...   \n",
              "10                                                 +\n",
              "   \n",
              "11  كن على ثقة أنك شخص عظم أوجده الله لهدف وغايةوو...   \n",
              "12                  تحيّة لكل بنت لون عيونها بئية © \n",
              "   \n",
              "13                                     احب نفسك أولا\n",
              "   \n",
              "\n",
              "                                             ref_text cer wer  \n",
              "0        خط لمحة النحيف خط لمحة العادي خط لمحة العريض          \n",
              "1                                   خط الطباعة العربي          \n",
              "2   مايسان ماذا تريد ماذا حصل أديسون ماذا قلتم ما ...          \n",
              "3   يقول الله تبارك وتعال واضرب لهم مثلا اصحاب الق...          \n",
              "4   كتبت بدري الاسماعيلي بالتعاون بين مدرس جميل بن...          \n",
              "5   صَعِدْتُ القِطار، تَوَجَّهْتُ إلى أَوَّلِ مَقْ...          \n",
              "6                           أدبُ المرءِ خيرٌ من ذهبهِ          \n",
              "7                                         موقع الفونت          \n",
              "8                                             العربية          \n",
              "9   بعد زبع قرن من الغياب والشوق لرؤية الاهل توفيت...          \n",
              "10                                         رمضان كريم          \n",
              "11  كن على ثقة أنّك شخص عظيم أوجده الله لهدف وغاية...          \n",
              "12                      تحيّة لكل بنت لون عيونهآ بنية          \n",
              "13                                      أحب نفسك أولا          "
            ],
            "text/html": [
              "\n",
              "  <div id=\"df-2bc7c4e0-5349-483f-a2de-3cd5ace31052\">\n",
              "    <div class=\"colab-df-container\">\n",
              "      <div>\n",
              "<style scoped>\n",
              "    .dataframe tbody tr th:only-of-type {\n",
              "        vertical-align: middle;\n",
              "    }\n",
              "\n",
              "    .dataframe tbody tr th {\n",
              "        vertical-align: top;\n",
              "    }\n",
              "\n",
              "    .dataframe thead th {\n",
              "        text-align: right;\n",
              "    }\n",
              "</style>\n",
              "<table border=\"1\" class=\"dataframe\">\n",
              "  <thead>\n",
              "    <tr style=\"text-align: right;\">\n",
              "      <th></th>\n",
              "      <th>img_filename</th>\n",
              "      <th>ocr_output</th>\n",
              "      <th>ref_text</th>\n",
              "      <th>cer</th>\n",
              "      <th>wer</th>\n",
              "    </tr>\n",
              "  </thead>\n",
              "  <tbody>\n",
              "    <tr>\n",
              "      <th>0</th>\n",
              "      <td>800_3566431_8sq3celupvg6gm1a5d9tosdp0549ix3r9d...</td>\n",
              "      <td>خط لمحة النحيفخط لمحة العاديخط لمحة العريض</td>\n",
              "      <td>خط لمحة النحيف خط لمحة العادي خط لمحة العريض</td>\n",
              "      <td></td>\n",
              "      <td></td>\n",
              "    </tr>\n",
              "    <tr>\n",
              "      <th>1</th>\n",
              "      <td>Arabic_Typesetting_Font.svg.png</td>\n",
              "      <td></td>\n",
              "      <td>خط الطباعة العربي</td>\n",
              "      <td></td>\n",
              "      <td></td>\n",
              "    </tr>\n",
              "    <tr>\n",
              "      <th>2</th>\n",
              "      <td>arabic-words-and-phrases-vector-22578359.jpg</td>\n",
              "      <td>ماما 5|اسل ملا: 2|د اننا لامملكحول</td>\n",
              "      <td>مايسان ماذا تريد ماذا حصل أديسون ماذا قلتم ما ...</td>\n",
              "      <td></td>\n",
              "      <td></td>\n",
              "    </tr>\n",
              "    <tr>\n",
              "      <th>3</th>\n",
              "      <td>capr10.png</td>\n",
              "      <td>يقول الله تبارك وتعال واضرب لهم مثلا اصحاب الق...</td>\n",
              "      <td>يقول الله تبارك وتعال واضرب لهم مثلا اصحاب الق...</td>\n",
              "      <td></td>\n",
              "      <td></td>\n",
              "    </tr>\n",
              "    <tr>\n",
              "      <th>4</th>\n",
              "      <td>capr2.png</td>\n",
              "      <td>كتبت بدري الاسماعيلي بالتعاون بين مدرس جميل بن...</td>\n",
              "      <td>كتبت بدري الاسماعيلي بالتعاون بين مدرس جميل بن...</td>\n",
              "      <td></td>\n",
              "      <td></td>\n",
              "    </tr>\n",
              "    <tr>\n",
              "      <th>5</th>\n",
              "      <td>cdd.jpg</td>\n",
              "      <td>2 ب٠ أ ا بيفي المحطةصَعِدتُ آلْقِطَار رَجَيْت...</td>\n",
              "      <td>صَعِدْتُ القِطار، تَوَجَّهْتُ إلى أَوَّلِ مَقْ...</td>\n",
              "      <td></td>\n",
              "      <td></td>\n",
              "    </tr>\n",
              "    <tr>\n",
              "      <th>6</th>\n",
              "      <td>cddd.jpg</td>\n",
              "      <td></td>\n",
              "      <td>أدبُ المرءِ خيرٌ من ذهبهِ</td>\n",
              "      <td></td>\n",
              "      <td></td>\n",
              "    </tr>\n",
              "    <tr>\n",
              "      <th>7</th>\n",
              "      <td>font_preview-ae8a8c44055469537eec30890fd91d074...</td>\n",
              "      <td>موقع الفونت</td>\n",
              "      <td>موقع الفونت</td>\n",
              "      <td></td>\n",
              "      <td></td>\n",
              "    </tr>\n",
              "    <tr>\n",
              "      <th>8</th>\n",
              "      <td>hand-writing-on-blackboard-language-260nw-4804...</td>\n",
              "      <td></td>\n",
              "      <td>العربية</td>\n",
              "      <td></td>\n",
              "      <td></td>\n",
              "    </tr>\n",
              "    <tr>\n",
              "      <th>9</th>\n",
              "      <td>kashida-justification.png</td>\n",
              "      <td>بعد زبع قرن من الغيابوالشوق لرؤية الاهل توفيتا...</td>\n",
              "      <td>بعد زبع قرن من الغياب والشوق لرؤية الاهل توفيت...</td>\n",
              "      <td></td>\n",
              "      <td></td>\n",
              "    </tr>\n",
              "    <tr>\n",
              "      <th>10</th>\n",
              "      <td>pngtree-ramadan-kareem-greetings-arabic-text-t...</td>\n",
              "      <td>+</td>\n",
              "      <td>رمضان كريم</td>\n",
              "      <td></td>\n",
              "      <td></td>\n",
              "    </tr>\n",
              "    <tr>\n",
              "      <th>11</th>\n",
              "      <td>r.jpg</td>\n",
              "      <td>كن على ثقة أنك شخص عظم أوجده الله لهدف وغايةوو...</td>\n",
              "      <td>كن على ثقة أنّك شخص عظيم أوجده الله لهدف وغاية...</td>\n",
              "      <td></td>\n",
              "      <td></td>\n",
              "    </tr>\n",
              "    <tr>\n",
              "      <th>12</th>\n",
              "      <td>sti.jpg</td>\n",
              "      <td>تحيّة لكل بنت لون عيونها بئية ©</td>\n",
              "      <td>تحيّة لكل بنت لون عيونهآ بنية</td>\n",
              "      <td></td>\n",
              "      <td></td>\n",
              "    </tr>\n",
              "    <tr>\n",
              "      <th>13</th>\n",
              "      <td>traditional-arabic-regular.png</td>\n",
              "      <td>احب نفسك أولا</td>\n",
              "      <td>أحب نفسك أولا</td>\n",
              "      <td></td>\n",
              "      <td></td>\n",
              "    </tr>\n",
              "  </tbody>\n",
              "</table>\n",
              "</div>\n",
              "      <button class=\"colab-df-convert\" onclick=\"convertToInteractive('df-2bc7c4e0-5349-483f-a2de-3cd5ace31052')\"\n",
              "              title=\"Convert this dataframe to an interactive table.\"\n",
              "              style=\"display:none;\">\n",
              "        \n",
              "  <svg xmlns=\"http://www.w3.org/2000/svg\" height=\"24px\"viewBox=\"0 0 24 24\"\n",
              "       width=\"24px\">\n",
              "    <path d=\"M0 0h24v24H0V0z\" fill=\"none\"/>\n",
              "    <path d=\"M18.56 5.44l.94 2.06.94-2.06 2.06-.94-2.06-.94-.94-2.06-.94 2.06-2.06.94zm-11 1L8.5 8.5l.94-2.06 2.06-.94-2.06-.94L8.5 2.5l-.94 2.06-2.06.94zm10 10l.94 2.06.94-2.06 2.06-.94-2.06-.94-.94-2.06-.94 2.06-2.06.94z\"/><path d=\"M17.41 7.96l-1.37-1.37c-.4-.4-.92-.59-1.43-.59-.52 0-1.04.2-1.43.59L10.3 9.45l-7.72 7.72c-.78.78-.78 2.05 0 2.83L4 21.41c.39.39.9.59 1.41.59.51 0 1.02-.2 1.41-.59l7.78-7.78 2.81-2.81c.8-.78.8-2.07 0-2.86zM5.41 20L4 18.59l7.72-7.72 1.47 1.35L5.41 20z\"/>\n",
              "  </svg>\n",
              "      </button>\n",
              "      \n",
              "  <style>\n",
              "    .colab-df-container {\n",
              "      display:flex;\n",
              "      flex-wrap:wrap;\n",
              "      gap: 12px;\n",
              "    }\n",
              "\n",
              "    .colab-df-convert {\n",
              "      background-color: #E8F0FE;\n",
              "      border: none;\n",
              "      border-radius: 50%;\n",
              "      cursor: pointer;\n",
              "      display: none;\n",
              "      fill: #1967D2;\n",
              "      height: 32px;\n",
              "      padding: 0 0 0 0;\n",
              "      width: 32px;\n",
              "    }\n",
              "\n",
              "    .colab-df-convert:hover {\n",
              "      background-color: #E2EBFA;\n",
              "      box-shadow: 0px 1px 2px rgba(60, 64, 67, 0.3), 0px 1px 3px 1px rgba(60, 64, 67, 0.15);\n",
              "      fill: #174EA6;\n",
              "    }\n",
              "\n",
              "    [theme=dark] .colab-df-convert {\n",
              "      background-color: #3B4455;\n",
              "      fill: #D2E3FC;\n",
              "    }\n",
              "\n",
              "    [theme=dark] .colab-df-convert:hover {\n",
              "      background-color: #434B5C;\n",
              "      box-shadow: 0px 1px 3px 1px rgba(0, 0, 0, 0.15);\n",
              "      filter: drop-shadow(0px 1px 2px rgba(0, 0, 0, 0.3));\n",
              "      fill: #FFFFFF;\n",
              "    }\n",
              "  </style>\n",
              "\n",
              "      <script>\n",
              "        const buttonEl =\n",
              "          document.querySelector('#df-2bc7c4e0-5349-483f-a2de-3cd5ace31052 button.colab-df-convert');\n",
              "        buttonEl.style.display =\n",
              "          google.colab.kernel.accessAllowed ? 'block' : 'none';\n",
              "\n",
              "        async function convertToInteractive(key) {\n",
              "          const element = document.querySelector('#df-2bc7c4e0-5349-483f-a2de-3cd5ace31052');\n",
              "          const dataTable =\n",
              "            await google.colab.kernel.invokeFunction('convertToInteractive',\n",
              "                                                     [key], {});\n",
              "          if (!dataTable) return;\n",
              "\n",
              "          const docLinkHtml = 'Like what you see? Visit the ' +\n",
              "            '<a target=\"_blank\" href=https://colab.research.google.com/notebooks/data_table.ipynb>data table notebook</a>'\n",
              "            + ' to learn more about interactive tables.';\n",
              "          element.innerHTML = '';\n",
              "          dataTable['output_type'] = 'display_data';\n",
              "          await google.colab.output.renderOutput(dataTable, element);\n",
              "          const docLink = document.createElement('div');\n",
              "          docLink.innerHTML = docLinkHtml;\n",
              "          element.appendChild(docLink);\n",
              "        }\n",
              "      </script>\n",
              "    </div>\n",
              "  </div>\n",
              "  "
            ]
          },
          "metadata": {},
          "execution_count": 98
        }
      ]
    },
    {
      "cell_type": "code",
      "source": [
        "for index, row in df_output.iterrows():\n",
        "  filename = row['img_filename']\n",
        "  ref = row['ref_text']\n",
        "  output = row['ocr_output']\n",
        "  cer = fastwer.score_sent(output, ref, char_level=True)\n",
        "  wer = fastwer.score_sent(output, ref, char_level=False)\n",
        "  df_output.loc[df_output['img_filename'] == filename, 'cer'] = round(cer,2) # Round value to 2 decimal places\n",
        "  df_output.loc[df_output['img_filename'] == filename, 'wer'] = round(wer,2)\n",
        "\n",
        "df_output"
      ],
      "metadata": {
        "colab": {
          "base_uri": "https://localhost:8080/",
          "height": 488
        },
        "id": "F4b9vxbCdZHX",
        "outputId": "ef08bcf6-6ad8-4347-dbd7-54a34cdcefc8"
      },
      "execution_count": null,
      "outputs": [
        {
          "output_type": "execute_result",
          "data": {
            "text/plain": [
              "                                         img_filename  \\\n",
              "0   800_3566431_8sq3celupvg6gm1a5d9tosdp0549ix3r9d...   \n",
              "1                     Arabic_Typesetting_Font.svg.png   \n",
              "2        arabic-words-and-phrases-vector-22578359.jpg   \n",
              "3                                          capr10.png   \n",
              "4                                           capr2.png   \n",
              "5                                             cdd.jpg   \n",
              "6                                            cddd.jpg   \n",
              "7   font_preview-ae8a8c44055469537eec30890fd91d074...   \n",
              "8   hand-writing-on-blackboard-language-260nw-4804...   \n",
              "9                           kashida-justification.png   \n",
              "10  pngtree-ramadan-kareem-greetings-arabic-text-t...   \n",
              "11                                              r.jpg   \n",
              "12                                            sti.jpg   \n",
              "13                     traditional-arabic-regular.png   \n",
              "\n",
              "                                           ocr_output  \\\n",
              "0        خط لمحة النحيفخط لمحة العاديخط لمحة العريض \n",
              "   \n",
              "1                                                   \n",
              "   \n",
              "2                ماما 5|اسل ملا: 2|د اننا لامملكحول \n",
              "   \n",
              "3   يقول الله تبارك وتعال واضرب لهم مثلا اصحاب الق...   \n",
              "4   كتبت بدري الاسماعيلي بالتعاون بين مدرس جميل بن...   \n",
              "5    2 ب٠ أ ا بيفي المحطةصَعِدتُ آلْقِطَار رَجَيْت...   \n",
              "6                                                   \n",
              "   \n",
              "7                                        موقع الفونت\n",
              "   \n",
              "8                                                   \n",
              "   \n",
              "9   بعد زبع قرن من الغيابوالشوق لرؤية الاهل توفيتا...   \n",
              "10                                                 +\n",
              "   \n",
              "11  كن على ثقة أنك شخص عظم أوجده الله لهدف وغايةوو...   \n",
              "12                  تحيّة لكل بنت لون عيونها بئية © \n",
              "   \n",
              "13                                     احب نفسك أولا\n",
              "   \n",
              "\n",
              "                                             ref_text    cer     wer  \n",
              "0        خط لمحة النحيف خط لمحة العادي خط لمحة العريض    5.0   55.56  \n",
              "1                                   خط الطباعة العربي  100.0   100.0  \n",
              "2   مايسان ماذا تريد ماذا حصل أديسون ماذا قلتم ما ...   69.8   100.0  \n",
              "3   يقول الله تبارك وتعال واضرب لهم مثلا اصحاب الق...   0.75   11.06  \n",
              "4   كتبت بدري الاسماعيلي بالتعاون بين مدرس جميل بن...   0.79   14.96  \n",
              "5   صَعِدْتُ القِطار، تَوَجَّهْتُ إلى أَوَّلِ مَقْ...  34.75  102.04  \n",
              "6                           أدبُ المرءِ خيرٌ من ذهبهِ  97.83   100.0  \n",
              "7                                         موقع الفونت   4.76    50.0  \n",
              "8                                             العربية  100.0   200.0  \n",
              "9   بعد زبع قرن من الغياب والشوق لرؤية الاهل توفيت...   4.53   51.02  \n",
              "10                                         رمضان كريم  100.0   100.0  \n",
              "11  كن على ثقة أنّك شخص عظيم أوجده الله لهدف وغاية...   5.52   36.21  \n",
              "12                      تحيّة لكل بنت لون عيونهآ بنية  15.09   66.67  \n",
              "13                                      أحب نفسك أولا   8.33   66.67  "
            ],
            "text/html": [
              "\n",
              "  <div id=\"df-884be005-ea8c-4432-a822-41fe44ef8c97\">\n",
              "    <div class=\"colab-df-container\">\n",
              "      <div>\n",
              "<style scoped>\n",
              "    .dataframe tbody tr th:only-of-type {\n",
              "        vertical-align: middle;\n",
              "    }\n",
              "\n",
              "    .dataframe tbody tr th {\n",
              "        vertical-align: top;\n",
              "    }\n",
              "\n",
              "    .dataframe thead th {\n",
              "        text-align: right;\n",
              "    }\n",
              "</style>\n",
              "<table border=\"1\" class=\"dataframe\">\n",
              "  <thead>\n",
              "    <tr style=\"text-align: right;\">\n",
              "      <th></th>\n",
              "      <th>img_filename</th>\n",
              "      <th>ocr_output</th>\n",
              "      <th>ref_text</th>\n",
              "      <th>cer</th>\n",
              "      <th>wer</th>\n",
              "    </tr>\n",
              "  </thead>\n",
              "  <tbody>\n",
              "    <tr>\n",
              "      <th>0</th>\n",
              "      <td>800_3566431_8sq3celupvg6gm1a5d9tosdp0549ix3r9d...</td>\n",
              "      <td>خط لمحة النحيفخط لمحة العاديخط لمحة العريض</td>\n",
              "      <td>خط لمحة النحيف خط لمحة العادي خط لمحة العريض</td>\n",
              "      <td>5.0</td>\n",
              "      <td>55.56</td>\n",
              "    </tr>\n",
              "    <tr>\n",
              "      <th>1</th>\n",
              "      <td>Arabic_Typesetting_Font.svg.png</td>\n",
              "      <td></td>\n",
              "      <td>خط الطباعة العربي</td>\n",
              "      <td>100.0</td>\n",
              "      <td>100.0</td>\n",
              "    </tr>\n",
              "    <tr>\n",
              "      <th>2</th>\n",
              "      <td>arabic-words-and-phrases-vector-22578359.jpg</td>\n",
              "      <td>ماما 5|اسل ملا: 2|د اننا لامملكحول</td>\n",
              "      <td>مايسان ماذا تريد ماذا حصل أديسون ماذا قلتم ما ...</td>\n",
              "      <td>69.8</td>\n",
              "      <td>100.0</td>\n",
              "    </tr>\n",
              "    <tr>\n",
              "      <th>3</th>\n",
              "      <td>capr10.png</td>\n",
              "      <td>يقول الله تبارك وتعال واضرب لهم مثلا اصحاب الق...</td>\n",
              "      <td>يقول الله تبارك وتعال واضرب لهم مثلا اصحاب الق...</td>\n",
              "      <td>0.75</td>\n",
              "      <td>11.06</td>\n",
              "    </tr>\n",
              "    <tr>\n",
              "      <th>4</th>\n",
              "      <td>capr2.png</td>\n",
              "      <td>كتبت بدري الاسماعيلي بالتعاون بين مدرس جميل بن...</td>\n",
              "      <td>كتبت بدري الاسماعيلي بالتعاون بين مدرس جميل بن...</td>\n",
              "      <td>0.79</td>\n",
              "      <td>14.96</td>\n",
              "    </tr>\n",
              "    <tr>\n",
              "      <th>5</th>\n",
              "      <td>cdd.jpg</td>\n",
              "      <td>2 ب٠ أ ا بيفي المحطةصَعِدتُ آلْقِطَار رَجَيْت...</td>\n",
              "      <td>صَعِدْتُ القِطار، تَوَجَّهْتُ إلى أَوَّلِ مَقْ...</td>\n",
              "      <td>34.75</td>\n",
              "      <td>102.04</td>\n",
              "    </tr>\n",
              "    <tr>\n",
              "      <th>6</th>\n",
              "      <td>cddd.jpg</td>\n",
              "      <td></td>\n",
              "      <td>أدبُ المرءِ خيرٌ من ذهبهِ</td>\n",
              "      <td>97.83</td>\n",
              "      <td>100.0</td>\n",
              "    </tr>\n",
              "    <tr>\n",
              "      <th>7</th>\n",
              "      <td>font_preview-ae8a8c44055469537eec30890fd91d074...</td>\n",
              "      <td>موقع الفونت</td>\n",
              "      <td>موقع الفونت</td>\n",
              "      <td>4.76</td>\n",
              "      <td>50.0</td>\n",
              "    </tr>\n",
              "    <tr>\n",
              "      <th>8</th>\n",
              "      <td>hand-writing-on-blackboard-language-260nw-4804...</td>\n",
              "      <td></td>\n",
              "      <td>العربية</td>\n",
              "      <td>100.0</td>\n",
              "      <td>200.0</td>\n",
              "    </tr>\n",
              "    <tr>\n",
              "      <th>9</th>\n",
              "      <td>kashida-justification.png</td>\n",
              "      <td>بعد زبع قرن من الغيابوالشوق لرؤية الاهل توفيتا...</td>\n",
              "      <td>بعد زبع قرن من الغياب والشوق لرؤية الاهل توفيت...</td>\n",
              "      <td>4.53</td>\n",
              "      <td>51.02</td>\n",
              "    </tr>\n",
              "    <tr>\n",
              "      <th>10</th>\n",
              "      <td>pngtree-ramadan-kareem-greetings-arabic-text-t...</td>\n",
              "      <td>+</td>\n",
              "      <td>رمضان كريم</td>\n",
              "      <td>100.0</td>\n",
              "      <td>100.0</td>\n",
              "    </tr>\n",
              "    <tr>\n",
              "      <th>11</th>\n",
              "      <td>r.jpg</td>\n",
              "      <td>كن على ثقة أنك شخص عظم أوجده الله لهدف وغايةوو...</td>\n",
              "      <td>كن على ثقة أنّك شخص عظيم أوجده الله لهدف وغاية...</td>\n",
              "      <td>5.52</td>\n",
              "      <td>36.21</td>\n",
              "    </tr>\n",
              "    <tr>\n",
              "      <th>12</th>\n",
              "      <td>sti.jpg</td>\n",
              "      <td>تحيّة لكل بنت لون عيونها بئية ©</td>\n",
              "      <td>تحيّة لكل بنت لون عيونهآ بنية</td>\n",
              "      <td>15.09</td>\n",
              "      <td>66.67</td>\n",
              "    </tr>\n",
              "    <tr>\n",
              "      <th>13</th>\n",
              "      <td>traditional-arabic-regular.png</td>\n",
              "      <td>احب نفسك أولا</td>\n",
              "      <td>أحب نفسك أولا</td>\n",
              "      <td>8.33</td>\n",
              "      <td>66.67</td>\n",
              "    </tr>\n",
              "  </tbody>\n",
              "</table>\n",
              "</div>\n",
              "      <button class=\"colab-df-convert\" onclick=\"convertToInteractive('df-884be005-ea8c-4432-a822-41fe44ef8c97')\"\n",
              "              title=\"Convert this dataframe to an interactive table.\"\n",
              "              style=\"display:none;\">\n",
              "        \n",
              "  <svg xmlns=\"http://www.w3.org/2000/svg\" height=\"24px\"viewBox=\"0 0 24 24\"\n",
              "       width=\"24px\">\n",
              "    <path d=\"M0 0h24v24H0V0z\" fill=\"none\"/>\n",
              "    <path d=\"M18.56 5.44l.94 2.06.94-2.06 2.06-.94-2.06-.94-.94-2.06-.94 2.06-2.06.94zm-11 1L8.5 8.5l.94-2.06 2.06-.94-2.06-.94L8.5 2.5l-.94 2.06-2.06.94zm10 10l.94 2.06.94-2.06 2.06-.94-2.06-.94-.94-2.06-.94 2.06-2.06.94z\"/><path d=\"M17.41 7.96l-1.37-1.37c-.4-.4-.92-.59-1.43-.59-.52 0-1.04.2-1.43.59L10.3 9.45l-7.72 7.72c-.78.78-.78 2.05 0 2.83L4 21.41c.39.39.9.59 1.41.59.51 0 1.02-.2 1.41-.59l7.78-7.78 2.81-2.81c.8-.78.8-2.07 0-2.86zM5.41 20L4 18.59l7.72-7.72 1.47 1.35L5.41 20z\"/>\n",
              "  </svg>\n",
              "      </button>\n",
              "      \n",
              "  <style>\n",
              "    .colab-df-container {\n",
              "      display:flex;\n",
              "      flex-wrap:wrap;\n",
              "      gap: 12px;\n",
              "    }\n",
              "\n",
              "    .colab-df-convert {\n",
              "      background-color: #E8F0FE;\n",
              "      border: none;\n",
              "      border-radius: 50%;\n",
              "      cursor: pointer;\n",
              "      display: none;\n",
              "      fill: #1967D2;\n",
              "      height: 32px;\n",
              "      padding: 0 0 0 0;\n",
              "      width: 32px;\n",
              "    }\n",
              "\n",
              "    .colab-df-convert:hover {\n",
              "      background-color: #E2EBFA;\n",
              "      box-shadow: 0px 1px 2px rgba(60, 64, 67, 0.3), 0px 1px 3px 1px rgba(60, 64, 67, 0.15);\n",
              "      fill: #174EA6;\n",
              "    }\n",
              "\n",
              "    [theme=dark] .colab-df-convert {\n",
              "      background-color: #3B4455;\n",
              "      fill: #D2E3FC;\n",
              "    }\n",
              "\n",
              "    [theme=dark] .colab-df-convert:hover {\n",
              "      background-color: #434B5C;\n",
              "      box-shadow: 0px 1px 3px 1px rgba(0, 0, 0, 0.15);\n",
              "      filter: drop-shadow(0px 1px 2px rgba(0, 0, 0, 0.3));\n",
              "      fill: #FFFFFF;\n",
              "    }\n",
              "  </style>\n",
              "\n",
              "      <script>\n",
              "        const buttonEl =\n",
              "          document.querySelector('#df-884be005-ea8c-4432-a822-41fe44ef8c97 button.colab-df-convert');\n",
              "        buttonEl.style.display =\n",
              "          google.colab.kernel.accessAllowed ? 'block' : 'none';\n",
              "\n",
              "        async function convertToInteractive(key) {\n",
              "          const element = document.querySelector('#df-884be005-ea8c-4432-a822-41fe44ef8c97');\n",
              "          const dataTable =\n",
              "            await google.colab.kernel.invokeFunction('convertToInteractive',\n",
              "                                                     [key], {});\n",
              "          if (!dataTable) return;\n",
              "\n",
              "          const docLinkHtml = 'Like what you see? Visit the ' +\n",
              "            '<a target=\"_blank\" href=https://colab.research.google.com/notebooks/data_table.ipynb>data table notebook</a>'\n",
              "            + ' to learn more about interactive tables.';\n",
              "          element.innerHTML = '';\n",
              "          dataTable['output_type'] = 'display_data';\n",
              "          await google.colab.output.renderOutput(dataTable, element);\n",
              "          const docLink = document.createElement('div');\n",
              "          docLink.innerHTML = docLinkHtml;\n",
              "          element.appendChild(docLink);\n",
              "        }\n",
              "      </script>\n",
              "    </div>\n",
              "  </div>\n",
              "  "
            ]
          },
          "metadata": {},
          "execution_count": 99
        }
      ]
    },
    {
      "cell_type": "code",
      "source": [
        "# Overall performances\n",
        "mean_cer = df_output['cer'].mean()\n",
        "mean_wer = df_output['wer'].mean()\n",
        "print(f'Mean CER = {mean_cer}%, Mean WER = {mean_wer}%')"
      ],
      "metadata": {
        "colab": {
          "base_uri": "https://localhost:8080/"
        },
        "id": "ohqJRDjIdZJU",
        "outputId": "6e93904a-24a8-463b-b9a7-a39f518115f0"
      },
      "execution_count": null,
      "outputs": [
        {
          "output_type": "stream",
          "name": "stdout",
          "text": [
            "Mean CER = 39.08214285714286%, Mean WER = 75.29928571428572%\n"
          ]
        }
      ]
    },
    {
      "cell_type": "code",
      "source": [
        "!tesseract --list-langs\n",
        "from google.colab import drive\n",
        "\n",
        "drive.mount('/content/drive')"
      ],
      "metadata": {
        "id": "lr58Gxx6MpFC",
        "colab": {
          "base_uri": "https://localhost:8080/"
        },
        "outputId": "61c00fa1-f1ce-4bac-e57c-037087f84abd"
      },
      "execution_count": null,
      "outputs": [
        {
          "output_type": "stream",
          "name": "stdout",
          "text": [
            "List of available languages (2):\n",
            "osd\n",
            "eng\n",
            "Mounted at /content/drive\n"
          ]
        }
      ]
    }
  ]
}